public class 上机实验题 {
    public static void main(String[] args) {
        String s = "ababababa";
        String longestNonOverlappingRepeating = findLongestNonOverlappingRepeatingSubstring(s);
        System.out.println("Longest non-overlapping repeating substring: " + longestNonOverlappingRepeating);
    }
    public static String findLongestNonOverlappingRepeatingSubstring(String s) {
        int n = s.length();
        String longestSubstring = "";

        // 枚举所有可能的子串长度
        for (int len = 1; len <= n / 2; len++) {
            // 检查是否存在长度为len的不重叠重复子串
            if (hasNonOverlappingRepeatingSubstring(s, len)) {
                String currentSubstring = s.substring(0, len);
                // 如果当前子串比已知的最长子串更长，则更新最长子串
                if (currentSubstring.length() > longestSubstring.length()) {
                    longestSubstring = currentSubstring;
                }
            }
        }

        // 如果找到了不重叠的重复子串，返回它；否则返回空字符串
        if (!longestSubstring.isEmpty()) {
            return repeatSubstring(s, longestSubstring);
        } else {
            return "";
        }
    }

    // 检查是否存在长度为len的不重叠重复子串
    private static boolean hasNonOverlappingRepeatingSubstring(String s, int len) {
        for (int i = 0; i <= s.length() - 2 * len; i++) {
            String sub1 = s.substring(i, i + len);
            String sub2 = s.substring(i + len, i + 2 * len);
            if (sub1.equals(sub2)) {
                return true;
            }
        }
        return false;
    }

    // 如果找到重复子串，重复拼接它直到不能再拼接为止
    private static String repeatSubstring(String s, String substring) {
        StringBuilder result = new StringBuilder(substring);
        int substringLength = substring.length();
        int remainingLength = s.length() - substringLength;

        while (remainingLength >= substringLength) {
            int index = s.indexOf(substring, result.length());
            if (index == result.length()) {
                result.append(substring);
                remainingLength -= substringLength;
            } else {
                break;
            }
        }

        return result.toString();
    }
}